/////////////////////////////////////////////////////
//    VOICEROID ǃAC talk program v0.1  by kako
/////////////////////////////////////////////////////

#if _MSC_VER < 1500
 #define _WIN32_WINNT (0x0500)
#endif

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 

#if _MSC_VER == 1400 // Visual Studio 2005
 #pragma warning(disable:4996)
#endif

#ifndef VK_OEM_2
 #define VK_OEM_2 0xBF
#endif

#define APP1 "VOICEROID - AC"
#define COMMAND "C:\\Program Files\\AHS\\Voiceroid\\Voiceroid.exe"
#define FOLDER "C:\\Program Files\\AHS\\Voiceroid\\"

char talk_string[8192];

HWND find_app_windows(char *app_name)
{
	HWND hwnd;
	hwnd=FindWindow(NULL,app_name); // Window's name
	if (hwnd==NULL) { return NULL; }
	return hwnd;
}

void run_Application(unsigned char *cmd,unsigned char *fld)
{
	SHELLEXECUTEINFO si;
	si.cbSize = sizeof(si); si.fMask = SEE_MASK_NOCLOSEPROCESS; si.hwnd = 0; si.nShow = SW_NORMAL;
	si.lpFile = (char *)cmd; si.lpParameters = NULL; si.lpDirectory = (char *)fld; si.lpVerb = "open";
	if( ! ShellExecuteEx(&si) ) { printf("Error: słȂ\n"); }
}

void SendKey_down(WORD ky)
{
	INPUT Key1;
	Key1.ki.wVk=ky; Key1.ki.wScan=(WORD)MapVirtualKey(ky,0); Key1.type=INPUT_KEYBOARD;
	Key1.ki.dwExtraInfo=0; Key1.ki.time=0; Key1.ki.dwFlags=0;
	SendInput(1,&Key1,sizeof(INPUT)); // key down
}

void SendKey_up(WORD ky)
{
	INPUT Key1;
	Key1.ki.wVk=ky; Key1.ki.wScan=(WORD)MapVirtualKey(ky,0); Key1.type=INPUT_KEYBOARD;
	Key1.ki.dwExtraInfo = 0; Key1.ki.time = 0; Key1.ki.dwFlags=KEYEVENTF_KEYUP;
	SendInput(1,&Key1,sizeof(INPUT)); // key up
}

void SendKey(WORD ky)
{
	SendKey_down(ky); SendKey_up(ky);
}

void SendKey_and_CTRL(WORD ky)
{
	SendKey_down(VK_CONTROL);  SendKey(ky);  SendKey_up(VK_CONTROL);
}

int LboxCopyClipboard(LPTSTR str)
{
	HGLOBAL hGlobal;
	LPTSTR mem;

	hGlobal=GlobalAlloc(GHND,lstrlen(str)+256);
	if (hGlobal==NULL) { return -1; } // error ... cannot allocate
	mem=(LPTSTR)GlobalLock(hGlobal);
	if (mem==NULL) { GlobalFree(hGlobal); return -1; } // error ... cannot lock
	lstrcpy(mem,str);
	GlobalUnlock(hGlobal);
	
	OpenClipboard(NULL);
	EmptyClipboard();
	SetClipboardData(CF_TEXT,hGlobal);
	CloseClipboard();
	return 0;
}

// C
int main(int argc , char *argv[])
{
	HWND	targetWnd;
	unsigned char cmd[255],fld[255];
	
	if (argc!=2) {
		printf("Usage: tsukuyomi_ai_talk string\n"); return 0;
	} else {
		strcpy(talk_string,argv[1]);
	}
	
	//ǃACɋNĂ邩`FbNANĂȂ΋N
	targetWnd=find_app_windows(APP1); // EBhET
	if (targetWnd==NULL) {
		printf("ǃACN܂\n");
		strcpy((char *)cmd,COMMAND); strcpy((char *)fld,FOLDER);
		run_Application(cmd,fld);
		for (int n=0;n<60;n++) {
			printf(".");
			Sleep(1000);
			targetWnd=find_app_windows(APP1); // EBhET
			if (targetWnd!=NULL) { break; }
		}
		if (targetWnd==NULL) { printf("ACȂ\n"); getchar(); return 1; }
		printf("\n");
		Sleep(3000); // Nē͂󂯕tԂɂȂ܂ŗ]3b҂
	}
	
	// EBhEANeBu,őOʂɂ
	ShowWindow(targetWnd,SW_SHOWNORMAL); SetForegroundWindow(targetWnd); 
	
	// Nbv{[hɃeLXg
	LboxCopyClipboard( talk_string );
	
	// L[Cxg𔭐
	Sleep(500);
	SendKey_and_CTRL(VK_OEM_2); // CTRL + '/'  ... all select
	SendKey(VK_DELETE); // Delete
	SendKey_and_CTRL('V'); // CTRL + V  ... paste clipboard
	Sleep(200);
	SendKey(VK_F5); // F5 ... speak
	
	printf("I\n");
	//getchar();
	return 0;
} 
